/* basename.c */

/* System headers */
#include <string.h>

/* Macros */
#define ISMBBLEAD(c) \
	(unsigned char)(((c) ^ 0x20) + 0x23) >= (unsigned char)((0x81 ^ 0x20) + 0x23)

/* Functions */
char *basename (const char *filename)
{
    const char *p = filename, *last;
    char c;

    /* hCu΂ */
    if (p[0] && p[1] == (char)':')
	p += 2;

    /* Ō̃pXf~^ */
    for (last = p; (c = *p++) != 0; ) {

	/* pXf~^Ȃ玟̈̕ʒuL */
	if (c == (char)'/' || c == (char)'\\')
	    last = p;

	/* ̓XLbv */
	else if (ISMBBLEAD (c) && *p)
	    p++;
    }

    /* x[XԂ */
    return (char *) last;
}
