
/* System headers */
#include <time.h>
#include <limits.h>
#include <sys/xtime.h>

/* Functions */
clock_t __const _ontime2clock (struct _ontime t)
{
    int day_max = 248 + (t.sec <= 4763647) ? 1 : 0;

    /* G[`FbN */
    if (t.day < 0 || day_max <= t.day)
	return LONG_MAX;

    /* clock_t ^ɕϊĕԂ */
    return (clock_t) (t.day * 8640000 + t.sec);
}
